/*****************************************************
Project :   
Date    : 5.01.2010
Author  :   .
Chip type           : ATmega8
Clock frequency     : 10,000000 MHz
Memory model        : Small
External RAM size   : 0
Data Stack size     : 256
*****************************************************/
#include <mega8.h>
#include <delay.h>
const char hl=180;
const char hh=179;
const char kk=243;
unsigned char ar[]={63,6,91,79,102,109,125,39,127,111};
unsigned char key=0;
unsigned char i=0;
unsigned char id=0;
unsigned char a =0;
unsigned char tm=0;
unsigned char temp=0;
unsigned char work=0;
unsigned char du=0;
unsigned char b=0;
unsigned char us=10;
unsigned char un=0;
unsigned char ut=0;
unsigned char tt=0;
unsigned char u=0;
unsigned char t=0;
unsigned char h=0;
unsigned char rr=0;
unsigned char zv=0;
unsigned char e =0;
bit p=0;
unsigned int cap =0;
unsigned int v =0;
// Timer 0 overflow interrupt service routine
//       0
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
if(++p==0){PORTC.3=0;}
else {PORTC.3=1;}
if (TCCR0==4){TCNT0=kk;}
}
// Timer 1 overflow interrupt service routine
//       1
interrupt [TIM1_OVF] void timer1_ovf_isr(void)
{
a++;
if (a==180){a=0; tm++;}
PORTB.0=a&1;
TCNT1L=hl;
TCNT1H=hh;
}
// Subroutine ADC
//      
void read_adc(void)
{
delay_us(10);
ADCSRA|=0x40;
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
}
//Subroutine of division for unsigned byte register
//   8  
void div(void)
{
temp=du;
h= temp/100;
temp = temp%100;
t=temp/10;
u= temp%10;
}
//Subroutine of output of data for low marks on indicator
//      
void strob(void)
{
if(id!=0)
 {
 if (id==1){PORTD=16;}
 if (id==2){PORTD=80;}
 if (id==3){PORTD=32;}
 PORTB.1=0;
 delay_ms(1);
 PORTB.1=1;
 }
PORTD=ar[h];
if(id!=2)
 {PORTD.7=1;}
PORTC.0=0;
delay_ms(1);
PORTC.0=1;
delay_ms(1);
PORTD=ar[t];
if(id==2){PORTD.7=1;}
PORTC.1=0;
delay_ms(1);
PORTC.1=1;
delay_ms(1);
PORTD=ar[u];
PORTC.2=0;
delay_ms(1);
PORTC.2=1;
delay_ms(1);
}
//Main programm
// 
void main(void)
{
unsigned char z =120;  //    
PORTB=0x37;
DDRB=0x3F;
PORTC=0x0F;
DDRC=0x0F;
PORTD=0x00;
DDRD=0xFF;
TCCR0=0x00;
TCNT0=0x00;
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;
ASSR=0x00;
TCCR2=0x6A;
TCNT2=0x00;
OCR2=0x00;
MCUCR=0x00;
TIMSK=0x05;
ACSR=0x80;
SFIOR=0x00;
ADCSRA=0x87;
ADMUX=101;
// Global enable interrupts
#asm("sei")
while (1)
      {
      id=0;
      read_adc();
      ut=ADCH;
      du=us;
      zv++;
      if (ut<10)
       {
        switch (zv)
        {
         case 1:
         TCCR0=3;       // 3000 
         break;
         case 3:
         TCCR0=3;
         break;
         case 5:
         TCCR0=3;
         break;
         default:TCCR0=0;   // 
        } 
       if (zv >= 20){zv=TCCR0=0;}   //   
       i=TCCR1B=0;
       PORTB.0=1;
       z=35;
        goto iz; 
       }
      ADMUX=100;
      read_adc();
      key=ADCH; 
      ADMUX=101;
      key= key & 224;   //   
      if (key == 32)    //   SB1
       {
        id=1;
        e++;
        switch(e)
        {
        case 5:
        e=4;
        goto ip;
        break;
        }
        goto ss;
        ip:
        id=3;
        if (b < 10)
        {
        if (i!= 255){i = i+5; b++;}
        }
        else 
        {
        if (i < 241) {i=i+15;}
        else {goto ex;}
        }
        goto ss;        
       }
      if (key == 64)    //   SB2
       {
        id=1;
        e++;
        switch(e)
        {
        case 5:
        e=4;
        goto im;
        break;
        }
        goto ss;        
        im:
        id=3;        
        if (b < 10)
        {
        if (i >= 5){i=i-5; b++;}
        }
        else 
        {
        if (i >= 15) {i=i-15;}
        else {goto ex;}
        }
        goto ss;       
       }
      if (key == 96)     //   SB3
       {
        if (b < 10)
        {
        if (us < 255){b++; us++;}
        }
        else 
        {
        if (us < 246) {us=us+10;}
        else {goto ex;}
        }
        goto ss;       
       }
      if (key == 128)   //   SB4
       {
        if (b < 10)
        {
        if (us >= 11){b++; us--;}
        }
        else
        {
        if (us >= 20) {us=us-10;}
        else {goto ex;}
        }
        goto ss;       
       }
      if (key == 160)    //   SB5
       {
       if (i!=0){goto ss;}    //
       id=2;
       OCR2 = 100;            //
       delay_ms(2);           
       read_adc();             
       un= ADCH;              //
       if (ut >= un)
        {                     
        rr=ut-un;             //
        } 
       goto ss;               
       }
      if (key == 224) {du=ut;}   //   SB6
      ex:
      b=e=0;
      ss:
      key=0;
      if (ut < us){i=0;}   //     
      if (i!=0) {cap=i*tm;TCCR1B=5;TCCR0=0;}
      else {
            TCCR1B=0; PORTB.0 = 1;
            switch (zv)
             {
             case 1:
             TCCR0=4;     // 600 
             break;
             case 3:
             TCCR0=4;
             break;
             default:TCCR0=0;
             }
             if (zv >= 20){zv=TCCR0=0;}  //   
             z=35; goto iz;
           }
      z=120;    //    
      iz:       //
      OCR2=i;
      div();
      if (h==0){PORTD=0;}
      else {PORTD=ar[h];}
      PORTB.5=0;
      delay_ms(1);
      PORTB.5=1;
      delay_ms(1);
      PORTD=ar[t];
      PORTD.7=1;
      PORTB.4=0;
      delay_ms(1);
      PORTB.4=1;
      delay_ms(1);
      PORTD=ar[u];
      PORTB.2=0;
      delay_ms(1);
      PORTB.2=1;
      delay_ms(1);
      if (id==0)
        {
         v= cap;
         tt= v/10000;
         v=v%10000;
         h=v/1000;
         v=v%1000;
         t=v/100;
         v=v%100;
         u=v/10;
         if (tt==0){PORTD=0;}
         else {PORTD=ar[tt];}
         PORTB.1=0;
         delay_ms(1);
         PORTB.1=1;
         delay_ms(1);
        }
      else
        {
         if (id!=2){work=i;}
         else {work=rr;}
         h= work/100;
         work = work%100;
         t=work/10;
         u= work%10;
        }
      strob();
      if(--z!=0){goto iz;}
      };
}
